package GUTI

import checkers.inference._

class GUTIWeightManager extends WeightManager {

  import GUTConstants._

  def weight(variables: List[Variable], constraints: List[Constraint]): List[WeightInfo] = {
    val res = new collection.mutable.ListBuffer[WeightInfo]()

    if (!InferenceMain.options.optNoWeights) {
      for (av <- variables) {
        av.varpos match {
          case _: FieldVP => {
            res += WeightInfo(av, REP, 80)
          }
          case _: ParameterVP => {
            res += WeightInfo(av, ANY, 150)
            // res += WeightInfo(av, PEER, 100)
          }
          case _: ReturnVP => {
            res += WeightInfo(av, REP, 30)
            // res += WeightInfo(av, PEER, 10)
          }
          case _: ClassTypeParameterVP => {
            res += WeightInfo(av, ANY, 200)
          }
          case _: MethodTypeParameterVP => {
            res += WeightInfo(av, ANY, 200)
          }
          case _: ExtendsVP => {
            // res += WeightInfo(av, ANY, 100)
          }
          case _: ImplementsVP => {
            // res += WeightInfo(av, ANY, 100)
          }

          case _: LocalInMethodVP => {
            // res += WeightInfo(av, REP, 10)
          }
          case _: LocalInStaticInitVP => {
            // res += WeightInfo(av, REP, 10)
          }

          case _: NewInMethodVP => {
            res += WeightInfo(av, REP, 80)
          }
          case _: NewInFieldInitVP => {
            res += WeightInfo(av, REP, 80)
          }
          case _: NewInStaticInitVP => {
            // res += WeightInfo(av, PEER, 80)
          }

          case _: CastInFieldInitVP => {
            // res += WeightInfo(av, ANY, 10)
          }
          case _: CastInMethodVP => {
            // res += WeightInfo(av, ANY, 10)
          }
          case _: CastInStaticInitVP => {
            // res += WeightInfo(av, ANY, 10)
          }

          case _: InstanceOfInFieldInitVP => {
            // res += WeightInfo(av, ANY, 10)
          }
          case _: InstanceOfInMethodVP => {
            // res += WeightInfo(av, ANY, 10)
          }
          case _: InstanceOfInStaticInitVP => {
            // res += WeightInfo(av, ANY, 10)
          }
        }
      }
    }

    res.toList
  }
}
